RTEMS: cpukit/include/rtems/rtl/rtl-obj-comp.h File Reference

| RTEMS 5.4-rc2

Loading...
Searching...
No Matches
Data Structures | Macros | Typedefs | Functions
rtl-obj-comp.h File Reference
API » RTEMS Runtime Link Editor

RTEMS Run-Time Linker Object File Compression manages a compressed stream of data. More...

`#include <rtems/rtl/rtl-obj-cache.h>`

Go to the source code of this file.

## Data Structures
struct | rtems_rtl_obj_cpmp

## Macros
#define | RTEMS_RTL_DECOMP_INPUT_SIZE (256)
#define | RTEMS_RTL_COMP_NONE (0)
#define | RTEMS_RTL_COMP_LZ77 (1)

## Typedefs
typedef struct rtems_rtl_obj_cpmp | rtems_rtl_obj_comp

## Functions
bool | rtems_rtl_obj_comp_open (rtems_rtl_obj_comp *comp, size_t size)
void | rtems_rtl_obj_comp_close (rtems_rtl_obj_comp *comp)
void | rtems_rtl_obj_comp_set (rtems_rtl_obj_comp *comp, rtems_rtl_obj_cache *cache, int fd, int compression, off_t offset)
bool | rtems_rtl_obj_comp_read (rtems_rtl_obj_comp *comp, void *buffer, size_t length)

## Detailed Description

RTEMS Run-Time Linker Object File Compression manages a compressed stream of data.

This is a simple interface to the object file cache to stream data from from a compressed object file. There is no ability to seek with the data from a compressed file. The module exists to allocate the output buffer when the loader starts and use the cache buffers will have been allocated.

## Macro Definition Documentation

## ◆ RTEMS_RTL_COMP_NONE

#define RTEMS_RTL_COMP_NONE (0)

The types of supported compression.

## ◆ RTEMS_RTL_DECOMP_INPUT_SIZE

#define RTEMS_RTL_DECOMP_INPUT_SIZE (256)

The amount of input data read at a time from the file.

## Typedef Documentation

## ◆ rtems_rtl_obj_comp

typedef struct rtems_rtl_obj_cpmp rtems_rtl_obj_comp

The compressed file.

## Function Documentation

## ◆ rtems_rtl_obj_comp_close()

void rtems_rtl_obj_comp_close | ( | rtems_rtl_obj_comp * | comp | ) |

Close a compressor.

Parameters

  comp | The compressor to close.

## ◆ rtems_rtl_obj_comp_open()

bool rtems_rtl_obj_comp_open | ( | rtems_rtl_obj_comp * | comp,
|  | size_t | size
| ) |  |

Open a compressor allocating the output buffer.

Parameters

  comp | The compressor to initialise.
  size | The size of the compressor's output buffer.

Return values

  true | The compressor is open.
  false | The compressor is not open. The RTL error is set.

## ◆ rtems_rtl_obj_comp_read()

bool rtems_rtl_obj_comp_read | ( | rtems_rtl_obj_comp * | comp,
|  | void * | buffer,
|  | size_t | length
| ) |  |

Read decompressed data. The length contains the amount of data that should be available in the cache and referenced by the buffer handle. It must be less than or equal to the size of the cache. This call will return the amount of data that is available. It can be less than you ask if the offset and size is past the end of the file.

Parameters

  comp | The compressor to read data from.
  buffer | The buffer the output is written too.
  length | The length of data to read. Can be modified to a lesser value and true is still returned so check it.

Return values

  true | The data referenced is in the cache.
  false | The read failed and the RTL error has been set.

## ◆ rtems_rtl_obj_comp_set()

void rtems_rtl_obj_comp_set | ( | rtems_rtl_obj_comp * | comp,
|  | rtems_rtl_obj_cache * | cache,
|  | int | fd,
|  | int | compression,
|  | off_t | offset
| ) |  |

Set the cache and offset in the file the compressed stream starts.

Parameters

  comp | The compressor to set the offset in.
  cache | The cache to read the file in by.
  fd | The file descriptor. Must be an open file.
  compression | The type of compression being streamed.
  offset | The offset in the file the compressed stream starts.